#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from . import mpfun
from models import *
from sqlalchemy.orm import Session

# 系统用户表

def sign_row(db: Session, row: SysUser) -> None:
    if row.sign != '':
        return
    
    user_id = str(row.user_id)
    user_name = mpfun.enc_data(row.user_name)
    password = mpfun.enc_data(row.password)
    nick_name = mpfun.base64_data(row.nick_name)
    dept_id = str(row.dept_id)
    dept_name = mpfun.base64_data(row.dept_name)
    email = mpfun.enc_data(row.email)
    phonenumber = mpfun.enc_data(row.phonenumber)
    status = str(row.status)
    del_flag = row.del_flag
    yzy_account = mpfun.enc_data(row.yzy_account)

    sign_data = ",".join([user_id, user_name, password, nick_name, dept_id, dept_name, email, phonenumber, status, del_flag, yzy_account])
    sign_hmac = mpfun.sign_data(sign_data)
    print('sign_tbl_user sign_data:', sign_data)
    print('sign_tbl_user sign_hmac:', sign_hmac)

    row.user_name = user_name
    row.password = password
    row.email = email
    row.phonenumber = phonenumber
    row.yzy_account = yzy_account
    row.sign = sign_hmac
    
    db.commit()

# 比较字段合并字符串是否和MAC值匹配上,调用密码服务器[验证HMAC]接口
def sign_valid_sign_row(row: SysUser) -> bool:
    if row.sign == '':
        return True
    
    user_id = str(row.user_id)
    user_name = row.user_name
    password = row.password
    nick_name = mpfun.base64_data(row.nick_name)
    dept_id = str(row.dept_id)
    dept_name = mpfun.base64_data(row.dept_name)
    email = row.email
    phonenumber = row.phonenumber
    status = str(row.status)
    del_flag = row.del_flag
    yzy_account = row.yzy_account

    # 原HMACSM3数值
    sign_hmac = row.sign
    print('sign_hmac:', sign_hmac)

    # 关键字段合并字符串
    sign_data = ",".join([user_id, user_name, password, nick_name, dept_id, dept_name, email, phonenumber, status, del_flag, yzy_account])
    print('sys_user resign_data:', sign_data)
    
    # 比较字段合并字符串是否和MAC值匹配上,调用密码服务器[验证HMAC]接口
    return mpfun.hmac_verify(sign_data, sign_hmac)